//+------------------------------------------------------------------+
//|                                                   VininI_AAA.mq4 |
//|                                Copyright  2010, Victor Nicolaev |
//|                                                    vinin.ucoz.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Victor Nicolaev"
#property link      "vinin.ucoz.ru"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Green
#property indicator_color3 Green

extern int     MODE_MA=4;  // MODE_SMA 0    
                           // MODE_EMA 1    
                           // MODE_SMMA 2    
                           // MODE_LWMA 3 -   
                           // MODE_LRMA 4  

extern int     CalculateBar=30;  //     *)
extern double  K=1;              //  

double MA[];
double SKOP[], SKOM[];


double Delta[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()  {
   IndicatorBuffers(4);
   string text;
   switch (MODE_MA){
      case MODE_SMA:  text="SMA("+CalculateBar+")"; break;
      case MODE_EMA:  text="EMA("+CalculateBar+")"; break;
      case MODE_SMMA: text="SMMA("+CalculateBar+")"; break;
      case MODE_LWMA: text="LWMA("+CalculateBar+")"; break;
      case 4:         text="LRMA("+CalculateBar+")"; break;
   }
   SetIndexBuffer(0,MA);     SetIndexStyle(0, DRAW_LINE);  SetIndexLabel(0,text);   SetIndexDrawBegin(0, 3*CalculateBar);
   SetIndexBuffer(1,SKOP);   SetIndexStyle(1, DRAW_LINE);  SetIndexLabel(1,"SKO+"); SetIndexDrawBegin(1, 3*CalculateBar);
   SetIndexBuffer(2,SKOM);   SetIndexStyle(2, DRAW_LINE);  SetIndexLabel(2,"SKO-"); SetIndexDrawBegin(2, 3*CalculateBar);

   SetIndexBuffer(3,Delta);


  
   
   
   
   

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()  {
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int    counted_bars=IndicatorCounted();
   int i, limit1=Bars-counted_bars-1;
   int limit2=limit1;
   int limit3=limit1;
   
   if (counted_bars==0) {
      limit1=Bars-CalculateBar-1;
      limit2=limit1-CalculateBar;
      limit3=limit2-CalculateBar;
   }
      
      
   switch (MODE_MA){
      case MODE_SMA:  
      case MODE_EMA:  
      case MODE_SMMA: 
      case MODE_LWMA: for (i=limit1;i>=0;i--)  MA[i]=iMA(NULL,0,CalculateBar,0,MODE_MA,PRICE_CLOSE,i);break;
      case 4:         for (i=limit1;i>=0;i--)  MA[i]=3.0*iMA(NULL,0,CalculateBar,0,MODE_LWMA,PRICE_CLOSE,i)-2.0*iMA(NULL,0,CalculateBar,0,MODE_SMA,PRICE_CLOSE,i); break;
   }
   
   for (i=limit2;i>=0;i--) {
      double tmp=MathMax(High[i]-MA[i],MA[i]-Low[i]);
      Delta[i]=tmp*tmp;
   }

   for (i=limit3;i>=0;i--) {
      tmp=iMAOnArray(Delta,0,CalculateBar,0,MODE_SMA,i);
      tmp=MathSqrt(tmp);
      SKOP[i]=MA[i]+K*tmp;
      SKOM[i]=MA[i]-K*tmp;
   }
   return(0);
  }
//+------------------------------------------------------------------+


